summaryrefslogtreecommitdiff
path: root/gettext-tools/tests/format-javascript-2
diff options
context:
space:
mode:
authorAndreas Stricker <astricker@futurelab.ch>2010-02-23 14:14:09 +0100
committerDaiki Ueno <ueno@gnu.org>2013-04-17 17:51:07 +0900
commitfe8db3b5b44cd23385e3dfccf54249b742d8d994 (patch)
tree127c653c910e4893b2061c0c1c2d7bae73a1d32b /gettext-tools/tests/format-javascript-2
parent97c6a779339a0de698606eaa42c347bcd027bfea (diff)
downloadgettext-fe8db3b5b44cd23385e3dfccf54249b742d8d994.tar.gz
Support for JavaScript.
Diffstat (limited to 'gettext-tools/tests/format-javascript-2')
-rw-r--r--gettext-tools/tests/format-javascript-288
1 files changed, 88 insertions, 0 deletions
diff --git a/gettext-tools/tests/format-javascript-2 b/gettext-tools/tests/format-javascript-2
new file mode 100644
index 000000000..3dfcfc821
--- /dev/null
+++ b/gettext-tools/tests/format-javascript-2
@@ -0,0 +1,88 @@
+#! /bin/sh
+
+# Test checking of JavaScript format strings.
+
+tmpfiles=""
+trap 'rm -fr $tmpfiles' 1 2 3 15
+
+tmpfiles="$tmpfiles f-js-2.data"
+cat <<\EOF > f-js-2.data
+# Valid: %% doesn't count
+msgid "abc%%def"
+msgstr "xyz"
+# Invalid: invalid msgstr
+msgid "abc%%def"
+msgstr "xyz%"
+# Valid: same arguments, with different widths
+msgid "abc%2sdef"
+msgstr "xyz%3s"
+# Invalid: too few arguments
+msgid "abc%sdef%u"
+msgstr "xyz%s"
+# Invalid: too many arguments
+msgid "abc%udef"
+msgstr "xyz%uvw%c"
+# Valid: type compatibility
+msgid "abc%o"
+msgstr "xyz%d"
+# Valid: type compatibility
+msgid "abc%o"
+msgstr "xyz%x"
+# Valid: type compatibility
+msgid "abc%o"
+msgstr "xyz%X"
+# Valid: type compatibility
+msgid "abc%d"
+msgstr "xyz%x"
+# Valid: type compatibility
+msgid "abc%d"
+msgstr "xyz%X"
+# Invalid: type incompatibility
+msgid "abc%c"
+msgstr "xyz%s"
+# Invalid: type incompatibility
+msgid "abc%c"
+msgstr "xyz%d"
+# Invalid: type incompatibility
+msgid "abc%s"
+msgstr "xyz%d"
+EOF
+
+: ${MSGFMT=msgfmt}
+n=0
+while read comment; do
+ read msgid_line
+ read msgstr_line
+ n=`expr $n + 1`
+ tmpfiles="$tmpfiles f-js-2-$n.po f-js-2-$n.mo"
+ cat <<EOF > f-js-2-$n.po
+#, python-format
+${msgid_line}
+${msgstr_line}
+EOF
+ fail=
+ if echo "$comment" | grep 'Valid:' > /dev/null; then
+ if ${MSGFMT} --check-format -o f-js-2-$n.mo f-js-2-$n.po; then
+ :
+ else
+ fail=yes
+ fi
+ else
+ ${MSGFMT} --check-format -o f-js-2-$n.mo f-js-2-$n.po 2> /dev/null
+ if test $? = 1; then
+ :
+ else
+ fail=yes
+ fi
+ fi
+ if test -n "$fail"; then
+ echo "Format string checking error:" 1>&2
+ cat f-js-2-$n.po 1>&2
+ exit 1
+ fi
+ rm -f f-js-2-$n.po f-js-2-$n.mo
+done < f-js-2.data
+
+rm -fr $tmpfiles
+
+exit 0